#!/usr/bin/env php
<?php

use Stub\StubData;
$model = new StubData();// Couche d'accès au model

    function displayActivityMenu() {
        echo "\n--- Gestion Activités ---\n";
        echo "1. Importer des données (FIT/GPX/TCX)/Manuel\n";
        echo "2. Synchroniser l'appareil de fréquence cardiaque\n";
        echo "3. Synchroniser l'app mobile\n";
        echo "4. Afficher les statistiques complète\n";
        echo "5. Visualiser les jauges de fréquence cardiaque\n";
        echo "6. Retour au menu principal\n";
        echo "Choisissez une option: ";
    }

    function activityActions() {
        global $model;
    
        while (true) {
            displayActivityMenu();
            $activityChoice = trim(fgets(STDIN));
    
            switch ($activityChoice) {
                case '1': // Importer des données (FIT/GPX/TCX)/Manuel
                    echo "\nChoisissez le type de fichier à importer (FIT/GPX/TCX) ou tapez 'Manuel' pour une saisie manuelle : ";
                    $fileType = trim(fgets(STDIN));
    
                    switch (strtoupper($fileType)) {
                        case 'FIT':
                        case 'GPX':
                        case 'TCX':
                            // Importer le fichier correspondant
                            $model->ActivityMgr->importFile($fileType);
                            break;
                        case 'MANUEL':
                            // Import manuel des données
                            $model->ActivityMgr->manualDataEntry();
                            break;
                        default:
                            echo "Type de fichier ou choix invalide.\n";
                            break;
                    }
                    break;
    
                case '2': // Synchroniser l'appareil de fréquence cardiaque
                    echo "\nSynchronisation de l'appareil de fréquence cardiaque en cours...\n";
                    $model->HeartRateDeviceMgr->sync();
                    break;
    
                case '3': // Synchroniser l'app mobile
                    echo "\nSynchronisation de l'app mobile en cours...\n";
                    $model->MobileAppMgr->sync();
                    break;
    
                case '4': // Afficher les statistiques complète
                    echo "\nStatistiques complètes :\n";
                    $model->StatisticsMgr->displayFullStats();
                    break;
    
                case '5': // Visualiser les jauges de fréquence cardiaque
                    echo "\nVisualisation des jauges de fréquence cardiaque :\n";
                    $model->HeartRateGaugeMgr->displayGauges();
                    break;
    
                case '6': // Retour au menu principal
                    return;
    
                default:
                    echo "Option invalide. Veuillez réessayer.\n";
                    break;
            }
        }
    }
    
function displaySocialMenu(){
    echo "\n--- Gestion Sociale ---\n";
    echo "1. Rechercher des utilisateurs\n";
    echo "2. Ajoutez amis\n";
    echo "2. Suprimez amis\n";
    echo "2. Voir amis\n";
    echo "3. Personnaliser le profil public\n";
    echo "4. Partager mes analyses\n";
    echo "5. Gérer la visibilité de mes activités\n";
    echo "6. Retour au menu principal\n";
    echo "Choisissez une option: ";
}

function displayMainAthleteMenu() {
    echo "\n--- Menu Athlète ---\n";
    echo "1. Voir le profil\n";
    echo "2. Modifier le profil\n";
    echo "10. Synchroniser un appareil\n";
    echo "3. Visualiser l'analyse de fréquence cardiaque\n";
    echo "4. Statistiques de condition physique\n";
    echo "3. Gérer actvité \n";

    echo "3. Retour au menu principal\n";
    echo "Choisissez une option: ";
}
function displayMainCoachMenu() {
    echo "\n--- Menu Coach ---\n";
    echo "1. Voir le profil coach\n";
    echo "2. Modifier le profil coach\n";
    echo "8. Visualiser les performances de l'équipe\n";
    echo "3. Retour au menu principal\n";
    echo "3. Gérer Athlètes\n";
    echo "Choisissez une option: ";
}

function DisplayCoachAthleteMenu(){
    echo "2. Ajoutez athlète\n";
    echo "2. Supprimer athlète\n";
    echo "2. Supprimer athlète\n";
    echo "1. Consulter les statistiques d'un athlete \n";

    echo "4. Retour au menu principal\n";
    echo "Choisissez une option: ";

}
function clearScreen()
{
    system('clear || cls');
}


function displayAuthMenu()
{
    clearScreen();
    echo "\n\n";
    echo "  +--------------------------+\n";
    echo "  |       Menu Principal     |\n";
    echo "  +--------------------------+\n";
    echo "  | 1. Se connecter          |\n";
    echo "  | 2. S'inscrire            |\n";
    echo "  | 0. Quitter               |\n";
    echo "  +--------------------------+\n";
    echo "  Choisissez une option: ";
}    



function loginUser() {
    echo "\nEntrez votre nom d'utilisateur: ";
    $username = trim(fgets(STDIN));
    echo "Entrez votre mot de passe: ";
    $password = trim(fgets(STDIN));
    global $model;
    if ($model->userMgr->login($username, $password)) {
        return true;
    } else {
        echo "Erreur de connexion. Essayez encore.\n";
        return false;
    }
}

function registerUser() {
    global $model;
    echo "\nEntrez votre nom d'utilisateur: ";
    $username = trim(fgets(STDIN));
    echo "Entrez votre mot de passe: ";
    $password = trim(fgets(STDIN));
    $model->userMgr->register($username, $password);
    echo "Utilisateur enregistré avec succès!\n";
    return true;
}


function athleteActions() {
    global $model;

    while (true) {
        displayMainAthleteMenu();
        $athleteChoice = trim(fgets(STDIN));

        switch ($athleteChoice) {
            case '1': // Voir le profil
                echo "\nProfil de l'athlète:\n";

                echo $model->userMgr->getCurrentUser() . "\n";

                break;

            case '2': // Modifier le profil
                echo "\nModifier le profil:\n";
                // Récupérer et modifier les informations de l'athlète
                echo "Entrez le nouveau nom (ou laissez vide pour ne pas changer) : ";
                $name = trim(fgets(STDIN));
                echo "Entrez le nouvel âge (ou laissez vide pour ne pas changer) : ";
                $age = trim(fgets(STDIN));
                
                // Mettre à jour le profil dans le modèle avec accept NULL
                $model->userMgr->updateProfile($name, $age);
                echo "Profil mis à jour avec succès!\n";
                break;

            case '3': // Synchroniser un appareil
                echo "\nSynchronisation de l'appareil en cours...\n";
                // Supposons que vous ayez une fonction pour synchroniser un appareil
                $model->DeviceMgr->syncDevice();
                break;

            case '4': // Visualiser l'analyse de fréquence cardiaque
                // Supposons que vous ayez une fonction qui affiche une analyse
                $model->HeartRateMgr->displayAnalysis();
                break;

            case '5': // Statistiques de condition physique
                // Supposons que vous ayez une fonction qui affiche des statistiques
                $model->FitnessMgr->displayStats();
                break;

            case '6': // Retour au menu principal
                return;

            default:
                echo "Option invalide. Veuillez réessayer.\n";
                break;
        }
    }
}


function coachActions() {
    while (true) {
        displayMainCoachMenu();
        $coachChoice = trim(fgets(STDIN));
        switch ($coachChoice) {
            case '1': // Voir le profil coach
                echo "Profil du coach...\n";
                break;
            case '2':
                echo "Modifier le profil coach...\n";
                break;
            case '3': // Retour au menu principal
                return;
            case '4': // Gérer Athlètes
                echo "Gérer Athlètes";
                break;
            default:
                echo "Option invalide. Veuillez réessayer.\n";
                break;
        }
    }
}
while (true) {
    displayAuthMenu();
    $choice = trim(fgets(STDIN));

    switch ($choice) {
        case '1': // Se connecter
            if (loginUser()) {
                if ($model->userMgr->getUser()::isCoach) {
                    coachActions();
                } else {
                    athleteActions();
                }
               
            }
            break;
            
        case '2': // S'inscrire
            registerUser();
            break;
            
        case '0': // Quitter
            echo "Merci d'avoir utilisé notre application. Au revoir !\n";
            exit(0);

        default:
            echo "Option invalide. Veuillez réessayer.\n";
            break;
    }
}
