<?php
use Exception\NotImplementedException;
use Model\IUserRepository;
use Service\IAuthService;
use Utils\Validation;

class AuthService implements IAuthService {
    private $userRepository;

    public function __construct(UserRepository $userRepository) {
        $this->userRepository = $userRepository;
    }

    public function login($username, $password) {

        $user = $this->userRepository->getUserByUsername($username);

        if (!$user) {
            throw new \Exception('Unable to find user with that name');
        }
        if ($user->isValidPassword($password)) {
            return true;
        } 
        
        return false;
    }
    public function register(string $username, string $password, ...$data): bool
    {
        throw new NotImplementedException("register method not implemented");
        }

    public function logoutUser(): void
    {
        throw new NotImplementedException("logout method not implemented");
    }

    public function isAuthenticated(): bool { 

        if (!isset($_SESSION['token'])){
            return false;
        }
        if(!isset($_SESSION['role'])){
            // get the user associate 
            // use middleware
            throw new NotImplementedException("should be able to get the user");
        }
        $login=Validation::clean_string($_SESSION['login']);
        $token = Validation::clean_string($_SESSION['token']);
        // should check with a helper class static method how to !this.jwtHelper.isTokenExpired(token);
        throw new NotImplementedException("should end this method");

      }
}